 
#include "StdAfx.h"
 
#include"io.h"
#include "ListOutFile.h"
 #include"MCBdoubledst.h"
 
 
 
CListOutFile::CListOutFile()
{
	FileListNum=0;
}
 
CListOutFile::~CListOutFile()
{
}
 
 
 
 
void CListOutFile::WriteBmp(CString fn,BYTE *Graphic_buf,int cx,int cy)
{
	CFile f;
//	BYTE buf[100]={0,255,0,0,};
	f.Open("sample.bmp",CFile::modeRead);
//	fread(&Bfh,sizeof(Bfh)-2,1,ft);
//		fread(&Bih,sizeof(Bih),1,ft);
	f.Read(&m_Bfh,sizeof(m_Bfh)-2);
	f.Read(&m_Bih,sizeof(m_Bih));

	f.Close();
	m_Bih.biHeight=cy;
	m_Bih.biWidth=cx;
	f.Open(fn,CFile::modeCreate|CFile::modeWrite);//|CFile::modeNoTruncate
	f.Write(&m_Bfh,sizeof(m_Bfh)-2);
	f.Write(&m_Bih,sizeof(m_Bih));
	
	//f.Write(buf,100);
//	int i,j;
//	for(i=0;i<m_Bih.biHeight;i++)
//		for(j=0;j<m_Bih.biWidth;j++)
//		{
			f.Write(Graphic_buf,cx*cy*3);
//		}
	f.Close();
}
void CListOutFile::ReadFileList()
{
	struct _finddata_t c_files;
    long hFile;
//	char str[200];
	CString str="",str2="";
	CString InFolder,OutFolder,ReadingName;
	InFolder=DEF_IN_FOLDER;
	OutFolder=DEF_OUT_FOLDER;
	ReadingName=InFolder+"\\*.wav";

	
	hFile = _findfirst("input_wav_files\\*.wav", &c_files );
	do
	{
		str.Format("%s\\%s",InFolder,c_files.name);
		m_InFileListName[FileListNum]=str;
		c_files.name[strlen(c_files.name)-4]=0;
			
		str2+=str+"   ";
		m_InFileListName[FileListNum]=str;
		str.Format("%s\\%s.bmp",OutFolder,c_files.name);
		m_OutFileListName[FileListNum]=str;
		
		FileListNum++;
		str2+=str+"\n";

	}
	while(_findnext( hFile, &c_files )==0);
	
	_findclose( hFile );
	AfxMessageBox(str2);
}
 
 
void CListOutFile::DoTranslations()
{
	FileListNum=0;
	ReadFileList();
	int i;
	

	m_Dsound=new Cds;
	m_Dsound->hwnd=m_hwnd;//cs.hwndParent;
	m_Dsound->InitDirectSound();


	//FileListNum=1;
	for(i=0;i<FileListNum;i++)
	{
		Trans(m_InFileListName[i],m_OutFileListName[i]);

	}
	delete m_Dsound;

}

void CListOutFile::Trans(CString fn1,CString fn2)
{
	LPDIRECTSOUNDBUFFER dsbuf;
	CMCBdoubledst ddst;
	DWORD datan=0;
	DWORD allocsize=20000*2;
	double *data;
	BYTE *GraphicBuf;
	int i,j,ii,jj,WidthBytes;
	int cx,cy;
	int Measure,r=0,g=0,b=0;

	CString str;

	dsbuf=m_Dsound->dsound_MakeStaticBuffer(m_Dsound->m_pDirectSound,fn1,1);
	//dsbuf->Play(0,0,0);
	allocsize=m_Dsound->GetSize(dsbuf);
	data=new double[allocsize];

	m_Dsound->WriteTodata(dsbuf,allocsize,data,&datan);

	ddst.m_Sampling=m_Dsound->GetSampling(dsbuf);
	ddst.m_Data=data;
	ddst.m_DataN=datan;
	ddst.FindMaxHz();
	ddst.AllocMap();
	ddst.MakeDstMap();
//	ddst.MakeDstMapFilter();
//	ddst.MakeDstMapFilter2();



	ddst.RemakeDataFromDstMap();

	m_Dsound->DataToDsBuf(dsbuf,ddst.m_DataN,ddst.m_RemakeData);
	delete ddst.m_RemakeData;
	dsbuf->Play(0,0,0);

	str.Format("%s%d.wav",fn2,ddst.m_MakeDstMapFilter_NUM);

	m_Dsound->WriteWaveFile(dsbuf,str);

	
	cx=ddst.m_nBlockNum*4;
	cy=ddst.m_n20hz;
//	str.Format("%d %d %f",cx,cy,ddst.m_DstMap_AllMax);
//	AfxMessageBox(str);
	WidthBytes=cx*3;
	GraphicBuf=new BYTE[cx*cy*3];
	for(i=0;i<ddst.m_nBlockNum;i++)
		for(j=0;j<ddst.m_n20hz;j++)
		{
			Measure=(int)fabs(ddst.m_DstMap[i][j]*200*10/ddst.m_DstMap_AllMax);
//			Measure=(int)fabs(ddst.m_MultifulDstSins[i][j]*3);
			r=0;b=0;g=0;
			if(Measure>200)
			{
				r=Measure*10/200+150;
				g=255;
			}
			else 
				g=Measure+50;

			for(ii=0;ii<4;ii++)
				for(jj=0;jj<1;jj++)
				{
					GraphicBuf[i*4*3+ii*3+(jj+j)*WidthBytes+0]=b;
					GraphicBuf[i*4*3+ii*3+(jj+j)*WidthBytes+1]=g;
					GraphicBuf[i*4*3+ii*3+(jj+j)*WidthBytes+2]=r;

				}
		}
	WriteBmp(fn2,GraphicBuf,cx,cy);
	
	ddst.ReleaseMap();
	
	delete data;
	delete GraphicBuf;
}